#include <bits/stdc++.h>

using namespace std;

int main() {
    int n; cin >> n;

    vector<int> a(n);
    for(int i = 0;i<n;i++){
        cin >> a[i];
    }

    int ans = 0;
    int c = 0;

    vector<pair<int,int>> s;

    for(int i = 1;i<n;i++){
        int j = i;
        while(a[j] < a[j-1]){
            ans += 2;
            swap(a[j], a[j-1]);
            c += 2;
            s.emplace_back(j-1, j);
            j--;
        }
    }

    cout << c/2 << endl;
    for(auto& e : s){
        cout << e.first+1 << ' ' << e.second+1 << endl;
    }

    return 0;
}